package ru.dbotthepony.mc.otm.capability;

import mekanism.api.energy.IStrictEnergyHandler;
import net.minecraftforge.common.capabilities.*;
import org.jetbrains.annotations.NotNull;
import ru.dbotthepony.mc.otm.capability.drive.IMatteryDrive;
import ru.dbotthepony.mc.otm.capability.matter.IMatterHandler;
import ru.dbotthepony.mc.otm.capability.matter.IReplicationTaskProvider;
import ru.dbotthepony.mc.otm.capability.matter.IPatternStorage;
import ru.dbotthepony.mc.otm.graph.matter.IMatterGraphNode;
import ru.dbotthepony.mc.otm.graph.storage.IStorageGraphNode;
import top.theillusivec4.curios.api.type.capability.ICurio;
import top.theillusivec4.curios.api.type.capability.ICuriosItemHandler;

import javax.annotation.Nonnull;

public class MatteryCapability {
	@Nonnull
	@NotNull
	public static final Capability<IMatteryEnergyStorage> ENERGY = CapabilityManager.get(new CapabilityToken<>() {});

	@Nonnull
	@NotNull
	public static final Capability<MatteryPlayerCapability> MATTERY_PLAYER = CapabilityManager.get(new CapabilityToken<>() {});

	@Nonnull
	@NotNull
	public static final Capability<IMatterHandler> MATTER = CapabilityManager.get(new CapabilityToken<>() {});

	@Nonnull
	@NotNull
	public static final Capability<IMatterGraphNode> MATTER_NODE = CapabilityManager.get(new CapabilityToken<>() {});

	@Nonnull
	@NotNull
	public static final Capability<IPatternStorage> PATTERN = CapabilityManager.get(new CapabilityToken<>() {});

	@Nonnull
	@NotNull
	public static final Capability<IReplicationTaskProvider> TASK = CapabilityManager.get(new CapabilityToken<>() {});

	@Nonnull
	@NotNull
	public static final Capability<IMatteryDrive> DRIVE = CapabilityManager.get(new CapabilityToken<>() {});

	@Nonnull
	@NotNull
	public static final Capability<IStorageGraphNode> STORAGE_NODE = CapabilityManager.get(new CapabilityToken<>() {});

	@Nonnull
	@NotNull
	public static final Capability<IStrictEnergyHandler> MEKANISM_ENERGY = CapabilityManager.get(new CapabilityToken<>() {});

	@Nonnull
	@NotNull
	public static final Capability<ICuriosItemHandler> CURIOS_INVENTORY = CapabilityManager.get(new CapabilityToken<>() {});

	@Nonnull
	@NotNull
	public static final Capability<ICurio> CURIOS_ITEM = CapabilityManager.get(new CapabilityToken<>() {});

	public static void register(RegisterCapabilitiesEvent event) {
		event.register(IMatteryEnergyStorage.class);
		event.register(MatteryPlayerCapability.class);
		event.register(IMatterHandler.class);
		event.register(IMatterGraphNode.class);
		event.register(IPatternStorage.class);
		event.register(IReplicationTaskProvider.class);
		event.register(IMatteryDrive.class);
		event.register(IStorageGraphNode.class);
	}
}
