package ru.dbotthepony.mc.otm.compat.mekanism

import mekanism.common.registries.MekanismItems
import net.minecraft.ChatFormatting
import net.minecraftforge.event.entity.player.ItemTooltipEvent
import net.minecraftforge.eventbus.api.SubscribeEvent
import ru.dbotthepony.mc.otm.core.TranslatableComponent
import ru.dbotthepony.mc.otm.capability.isMekanismLoaded

private val BLACKHOLE_IMMUNITY = TranslatableComponent("otm.item.blackhole_immunity").withStyle(ChatFormatting.DARK_GRAY)

fun tooltipEvent(event: ItemTooltipEvent) {
	if (!isMekanismLoaded) {
		throw IllegalStateException("Mekanism is not loaded!")
	}

	if (event.itemStack.`is`(MekanismItems.MODULE_GRAVITATIONAL_MODULATING.get())) {
		event.toolTip.add(BLACKHOLE_IMMUNITY)
	}
}
