package ru.dbotthepony.mc.otm.core

import net.minecraft.world.inventory.AbstractContainerMenu
import net.minecraft.world.inventory.Slot
import net.minecraft.world.item.ItemStack

private class SlotIterator(private val parent: Iterator<Slot>) : MutableIterator<ItemStack> {
	private var last: Slot? = null

	override fun hasNext(): Boolean {
		return parent.hasNext()
	}

	override fun next(): ItemStack {
		return parent.next().also { last = it }.item
	}

	override fun remove() {
		val last = last ?: throw IllegalStateException("Never called next()")
		last.set(ItemStack.EMPTY)
	}
}

fun AbstractContainerMenu.itemStackIterator() : MutableIterator<ItemStack> = SlotIterator(slots.iterator())
fun Iterable<Slot>.itemStackIterator() : MutableIterator<ItemStack> = SlotIterator(iterator())
fun Iterator<Slot>.asItemStackIterator() : MutableIterator<ItemStack> = SlotIterator(this)
